/* lab10b.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

#define I_MAX_CARROS    254
#define SZ_FORMATO      "Formato: p <#carros>\n"
#define SZ_MAX_CARROS   "O maximo de carros permitido e' %d.\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d.\n"
#define SZ_NUM_CARROS   "Numero de carros %d.\n"
#define SZ_INDO_SUL     "Carro %d indo para o sul.\n"
#define SZ_INDO_NORTE   "Carro %d indo para o norte.\n"
#define SZ_CONSEG_SUL   "Carro %d conseguiu ir para o sul.\n"
#define SZ_CONSEG_NORTE "Carro %d conseguiu ir para o norte.\n"
#define SZ_CHEGU_SUL    "Carro %d chegou no sul.\n"
#define SZ_CHEGU_NORTE  "Carro %d chegou no norte.\n"
#define SZ_CARROS_SUL   "Carros indo para o sul %d.\n"
#define SZ_CARROS_NORTE "Carros indo para o norte %d.\n"


typedef struct {
   pthread_mutex_t MonitorPonte ;
   pthread_cond_t  CondSul      ,
                   CondNorte    ;
   int             iIndoSul     ,
                   iIndoNorte   ;
} tpMonPonte ;

 
tpMonPonte MonPonte  ; 


void* Passear( void* MeuId ) ;
   
void IrParaSul( int iMeuId ) ;

void IrParaNorte( int iMeuId ) ;

void ChegarNoSul( int iMeuId ) ;

void ChegarNoNorte( int iMeuId ) ;

void Esperar( int iMeuId ) ;


void* Passear( void* MeuId ) {
   int iMeuId = *( int* )MeuId ;

   while ( 1 ) {
      IrParaSul( iMeuId ) ;
      Esperar( iMeuId ) ;
      ChegarNoSul( iMeuId ) ;
      Esperar( iMeuId ) ;      
      IrParaNorte( iMeuId ) ;
      Esperar( iMeuId ) ;
      ChegarNoNorte( iMeuId ) ;
      Esperar( iMeuId ) ;
   } /* while */

} /* Passear */


void IrParaSul( int iMeuId ) {
   pthread_mutex_lock( &MonPonte.MonitorPonte ) ;

   printf( SZ_INDO_SUL, iMeuId ) ;
   fflush( stdout ) ;

   while ( MonPonte.iIndoNorte > 0 ) {
      pthread_cond_wait( &MonPonte.CondSul, &MonPonte.MonitorPonte ) ;
   } /* while */

   printf( SZ_CARROS_NORTE, MonPonte.iIndoNorte ) ;
   printf( SZ_CARROS_SUL, MonPonte.iIndoSul ) ;
   printf( SZ_CONSEG_SUL, iMeuId ) ;
   fflush( stdout ) ;
   
   MonPonte.iIndoSul++ ;
   pthread_cond_broadcast( &MonPonte.CondSul ) ;

   pthread_mutex_unlock( &MonPonte.MonitorPonte ) ;
} /* irParaSul */


void IrParaNorte( int iMeuId ) {
   pthread_mutex_lock( &MonPonte.MonitorPonte ) ;

   printf( SZ_INDO_NORTE, iMeuId ) ;
   fflush( stdout ) ;

   while ( MonPonte.iIndoSul > 0 ) {
      pthread_cond_wait( &MonPonte.CondNorte, &MonPonte.MonitorPonte ) ;
   } /* while */

   printf( SZ_CARROS_NORTE, MonPonte.iIndoNorte ) ;
   printf( SZ_CARROS_SUL, MonPonte.iIndoSul ) ;   
   printf( SZ_CONSEG_NORTE, iMeuId ) ;
   fflush( stdout ) ;
   
   MonPonte.iIndoNorte++ ;
   pthread_cond_broadcast( &MonPonte.CondNorte ) ;

   pthread_mutex_unlock( &MonPonte.MonitorPonte ) ;
} /* irParaNorte */ 


void ChegarNoSul( int iMeuId ) {
   pthread_mutex_lock( &MonPonte.MonitorPonte ) ;

   printf( SZ_CHEGU_SUL, iMeuId ) ;
   fflush( stdout ) ;
   MonPonte.iIndoSul-- ;

   if ( MonPonte.iIndoSul == 0 ) {
      pthread_cond_broadcast( &MonPonte.CondNorte ) ;
   } /* if */

   pthread_mutex_unlock( &MonPonte.MonitorPonte ) ;
} /* ChegarNoSul */


void ChegarNoNorte( int iMeuId ) {
   pthread_mutex_lock( &MonPonte.MonitorPonte ) ;

   printf( SZ_CHEGU_NORTE, iMeuId ) ;
   fflush( stdout ) ;
   MonPonte.iIndoNorte-- ;

   if ( MonPonte.iIndoNorte == 0 ) {
      pthread_cond_broadcast( &MonPonte.CondSul ) ;
   } /* if */

   pthread_mutex_unlock( &MonPonte.MonitorPonte ) ;
} /* ChegarNoNorte */

 
void Esperar( int iMeuId ) {
   unsigned long int i                                        ,
                     lTotal = ( unsigned long )10000000L 
                            * ( unsigned long )( iMeuId + 1 ) ;

   for ( i = 0 ; i < lTotal ; i++ ) { }
} /* Esperar */


int main( int   argc    ,
          char* argv[ ]  ) {
   int       i                      ,
             iNumCarros             ,
             iErro                  ;
   int*      pMeuId                 ;
   pthread_t Thread[ I_MAX_CARROS ] ;

   if ( argc != 2 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   iNumCarros = atoi( argv[ 1 ] ) ;

   if ( iNumCarros > I_MAX_CARROS ) {
      printf( SZ_MAX_CARROS, I_MAX_CARROS ) ;
      return 0 ;
   } /* if */

   printf( SZ_NUM_CARROS, iNumCarros ) ;

   for ( i = 0 ; i < iNumCarros ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;

      iErro = pthread_create( &Thread[ i ], NULL, Passear,
                                                  ( void* )( pMeuId ) ) ;

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   pthread_exit( NULL ) ;

   return 0 ;
}
